## @knitr def_func
    ## ֐̒`
sd.distr <- function(x) {  # sd, K̎Zo
  x <- x[!is.na(x)]
  n <- length(x)
  m <- mean(x)  # ϒl
  sd99 <- sd(x)
  var100 <- var(x) * (n-1) / n  # W{U
  sd100 <- sqrt(var100)  # W{W΍
  shpRes <- -1
  shp <- tryCatch({shapiro.test(x)}, error = function(e) {NULL})
  if (!is.null(shp)) shpRes <- shp$p.value
  return(c(=m, W{W΍=sd100, sΕW΍=sd99, K=shpRes))
}


## @knitr set_data
    # ɂfރf[^t[쐬
    # , , g, ̏d@500l
n <- 500
sex <- as.integer(runif(n, min=1, max=4))
sex <- factor(sex, levels=c(1,2,3),
    labels=c("", "j", ""), exclude=NULL)
count <- table(sex)
ht <- list()
wt <- list()
for (s in levels(sex)) {
  if (s == "") {
    ht[[s]] <- rnorm(n=count[[s]], mean=162.0, sd=6.0)
    bmi <- runif(count[[s]], min=17.5, max=26.0)
    wt[[s]] <- bmi * (ht[[s]] / 100.0)^2
  }
  else if (s == "j") {
    ht[[s]] <- rnorm(n=count[[s]], mean=167.0, sd=6.0)
    bmi <- runif(count[[s]], min=18.0, max=28.5)
    wt[[s]] <- bmi * (ht[[s]] / 100.0)^2
  }
  else {  # 
    ht[[s]] <- rnorm(n=count[[s]], mean=165.0, sd=6.0)
    bmi <- runif(count[[s]], min=17.5, max=27.5)
    wt[[s]] <- bmi * (ht[[s]] / 100.0)^2
  }
}
ct <- list()
for (s in levels(sex))  ct[[s]] <- 0
height <- c()
weight <- c()
for (s in sex) {
  ct[[s]] <- ct[[s]] + 1
  height <- c(height, ht[[s]][ct[[s]]])
  weight <- c(weight, wt[[s]][ct[[s]]])
}
dtf <- data.frame(hc=(1:n), =sex,
    g=round(height,1), ̏d=round(weight,1))
write.csv(dtf, file="mtest02.csv", quote=T, row.names=F)  # csvo


## @knitr first
#' # ͂߂
#'
#' gƑ̏dɂāAʂ肪ɕށEl@B
#'
#' ʂ̓(l)͉̂ƂB
#'
#' ```{r echo=FALSE}
#' kable(count.mtx, format="markdown", align="rrrr")
#' ```
#'
#' --------
#'
eval(set.template)

    # {Iȕϐݒ
nums <- c("g", "̏d")  # Ώۂ̐l̗
key <- ""  # ނ̎肪ƂȂ̖O
key.lvl <- levels(dtf[,key])
key.color <- c("red", "blue", "green3", "cyan", "magenta", "yellow", "gray")
    # ʂ̐l̓Zo
frq <- table(dtf[,key])
pct <- addmargins(prop.table(frq)*100.0)
frq <- addmargins(frq)
frq <- sprintf("%d", frq)
pct <- sprintf("%.1f", pct)
mtx <- cbind(frq, pct)
rownames(mtx) <- c(key.lvl, "")
colnames(mtx) <- c("l(l)", "䗦(%)")
count.mtx <- t(mtx)
append.mrmd(template[1])


## @knitr distribution
#' # z̗v
#'
#'@ł͕zɊւ\IȒlFŏlAőlAϒlȂǂfB
#'
#'@ȉŁu1^4ʁv́A1̎lʓ_B
#'

#' ## %ssummary
#'
#' @%s̕z\IȒl͎̂ƂD
#' ```{r echo=FALSE}
#' kable(summary.tbl[["%s"]], format="markdown")
#' ```
#' 
#' --------
#' 
#' @%s̕W΍CK(shapiro.testɂ)͉̂ƂD
#' ```{r echo=FALSE}
#' kable(sd.tbl2[["%s"]], format="markdown", align="rrrl")
#' ```
#' 
#' --------
#'
eval(set.template)

      ## summaryɂ镪z󋵂̔c
  xx <- lapply(nums, function(i) tapply(dtf[,i], dtf[,key], summary))
  names(xx) <- nums
  xx <- lapply(xx, function(x) lapply(x, function(k) k[names(k) != "NA's"]))
  yy <- lapply(nums, function(i) sapply(key.lvl, function(j) xx[[i]][[j]]))
  names(yy) <- nums
  ww <- lapply(nums, function(i) summary(dtf[,i]))
  names(ww) <- nums
  ww <- lapply(ww, function(k) k[names(k) != "NA's"])
  summary.tbl <- lapply(nums, function(i) t(cbind(yy[[i]], S=ww[[i]])))
  names(summary.tbl) <- nums
  jp.names <- c("ŏl", "1^4", "l", "ϒl", "3^4", "ől")
  for (i in nums)  colnames(summary.tbl[[i]]) <- jp.names
      ## W΍CK̔c
  xx <- lapply(nums, function(i) tapply(dtf[,i], dtf[,key], sd.distr))
  names(xx) <- nums
  yy <- lapply(nums, function(i) sapply(key.lvl, function(j) xx[[i]][[j]]))
  names(yy) <- nums
  ww <- lapply(nums, function(i) sd.distr(dtf[,i]))
  names(ww) <- nums
  sd.tbl <- lapply(nums, function(i) t(cbind(yy[[i]], S=ww[[i]])))
  names(sd.tbl) <- nums
      ## sd.tbl\pɏC
  sd.tbl2 <- lapply(nums, function(k) {
    mm <- sd.tbl[[k]]
    mm2 <- mm
    for (j in 1:3) {
      for (i in 1:nrow(mm))
        mm2[i,j] <- if (is.na(mm[i,j])) "" else sprintf("%.2f", mm[i,j])
    }
    for (i in 1:nrow(mm)) {
      pv <- mm[i,4]
      if (pv < 0) {mm2[i,4] <- "s\"}
      else if (pv < 0.05) {mm2[i,4] <- sprintf("No (p=%f)", pv)}
      else {mm2[i,4] <- sprintf("Yes(p=%f)", pv)}
    }
    return(mm2)
  })
  names(sd.tbl2) <- nums
      ## ʂrmarkdownƂċL^
  append.mrmd(template[1])
  for (i in nums) {
    fmt <- gsub("%s", i, template[2])
    append.mrmd(fmt)
  }


## @knitr histgram
#' # xz\ƃqXgO
#'
#' @xz\Ƃ̃qXgOfD
#'
#' @ȉ̓xz\ɂĎ̓_ɗӁB
#'
#' - l͈̔͂u160`170vȂǂ́Cu160ȏE170v̈Ӗ
#' - ʓ́uvvɑ΂䗦()
#'

#' ## %s̓xz
#'
#' ```{r echo=FALSE}
#' kable(frq.tbl[["%s"]], format="markdown", align="rrrr")
#' ```
#' 
#' iʓrfڂ̃qXgOQƁj
#'
#' `r img.list[["%s"]]`
#'
#' --------
#'
eval(set.template)

      ## xz\̍쐬
  frq.tbl <- lapply(nums, function(n) {
      a <- dtf[,n]
      h <- hist(a, include.lowest=T, right=F, plot=F)
      brk <- h$breaks
      lbl <- sapply(1:(length(brk)-1), function(i)
          sprintf("%s`%s", brk[i], brk[i+1]))
      x <- dtf[,key]
      y <- cut(a, breaks=brk, labels=lbl, right=FALSE)
      frq <- table(x, y)
      xx <- prop.table(addmargins(frq,1), 1)*100
      pct <- addmargins(xx, 2)
      frq <- addmargins(frq)
      rownames(frq) <- sub("Sum", "v", rownames(frq))
      colnames(frq) <- sub("Sum", "v", colnames(frq))
      names(dimnames(frq)) <- c(key, n)
      nr <- nrow(frq)
      nc <- ncol(frq)
      jtbl <- sapply(1:nr, function(i)
          sapply(1:nc, function(j) gsub("  ", "@",
              sprintf("%d(%5.1f)", frq[i,j], pct[i,j]))))
      jtbl <- t(jtbl)
      rownames(jtbl) <- rownames(frq)
      colnames(jtbl) <- colnames(frq)
      jtbl <- as.table(jtbl)
      if (nc > nr)
          jtbl <- t(jtbl)
      return(jtbl)})
  names(frq.tbl) <- nums

      ## qXgO̍쐬
  item.color <- sapply(1:length(key.lvl), function(i) sprintf("%s:%s",
    key.lvl[i], key.color[i]))
  color.str <- sprintf("(%s)", paste(item.color, collapse="C"))
  xx <- lapply(nums, function(i) tapply(dtf[,i], dtf[,key],
      function(x) na.omit(x)))
  names(xx) <- nums
  img.list <- list()
  for (i in 1:length(nums)) {
      n <- nums[i]
      hist.file <- sprintf("image%02d.png", i)
      hist.title <- sprintf("%s̃qXgO", n)
      img.list <- append(img.list, list(sprintf("![%s](%s)",
          hist.title, hist.file)))
      w <- na.omit(dtf[,n])
      hw <- hist(w, include.lowest=T, right=F, plot=F)
      brk <- hw$breaks
      if (file.exists(hist.file))  file.remove(hist.file)
      png(file=hist.file)
      par(family = "Japan1GothicBBB")  # {tHgɃS`bNw
      plot(0, 0, type="n", xlim=c(min(brk), max(brk)),
          ylim=c(0, max(hw$counts)), xlab=n, ylab="x",
          main=hist.title, sub=color.str)
      for (j in 1:length(key.lvl)) {
          k <- key.lvl[j]
          x <- xx[[n]][[k]]
          h <- hist(x, breaks=brk, include.lowest=T, right=F)
          lines(h$mids, h$counts, col=key.color[j])
      }
      dev.off()
  }
  names(img.list) <- nums
      # ʂrmarkdownƂċL^
  append.mrmd(template[1])
  for (i in nums) {
    fmt <- gsub("%s", i, template[2])
    append.mrmd(fmt)
  }

